<template>
  <div class="app-container">

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
        >新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          plain
          icon="el-icon-edit"
          size="mini"
          :disabled="single"
          @click="handleUpdate"
        >修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
        >删除</el-button>
      </el-col>
<!--      <el-col :span="1.5">-->
<!--        <el-button-->
<!--          type="warning"-->
<!--          plain-->
<!--          icon="el-icon-download"-->
<!--          size="mini"-->
<!--          @click="handleExport"-->
<!--          v-hasPermi="['mall:mallMemberBanner:export']"-->
<!--        >导出</el-button>-->
<!--      </el-col>-->
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="mallMemberBannerList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
<!--      <el-table-column label="用户轮播图主键ID" align="center" prop="id" />-->
<!--      <el-table-column label="图片名称" align="center" prop="name" />-->
      <el-table-column label="图片" align="center" prop="headUrl" width="100">
        <template slot-scope="scope">
          <image-preview :src="scope.row.headUrl" :width="50" :height="50"/>
        </template>
      </el-table-column>
<!--      <el-table-column label="背景图图片" align="center" prop="backgroundUrl" width="100">-->
<!--        <template slot-scope="scope">-->
<!--          <image-preview :src="scope.row.backgroundUrl" :width="50" :height="50"/>-->
<!--        </template>-->
<!--      </el-table-column>-->
<!--      <el-table-column label="轮播状态：0-正常，1-隐藏" align="center" prop="status" />-->
<!--      <el-table-column label="轮播类型:：0-不跳转" align="center" prop="type" />-->
      <el-table-column label="排序(正序)" align="center" prop="sort" />
      <el-table-column label="创建时间" align="center" prop="createAt" />
<!--      <el-table-column label="修改时间" align="center" prop="updateAt" />-->
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
          >修改</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
          >删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改用户轮播图对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="500px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="图片">
          <image-upload v-model="form.headUrl" :limit="1"/>
        </el-form-item>
        <el-form-item label="排序(正序)" prop="sort">
          <el-input-number v-model="form.sort" :min="0" :precision="0" controls-position="right" placeholder="请输入排序" />
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { listMallMemberBanner, getMallMemberBanner, delMallMemberBanner, addMallMemberBanner, updateMallMemberBanner } from "@/api/mall/mallMemberBanner";

export default {
  name: "MallMemberBanner",
  props: ["memberUserId"],
  data() {
    return {
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 用户轮播图表格数据
      mallMemberBannerList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        memberUserId: null,
        name: null,
        status: null,
        type: null,
        sort: null,
        createAt: null,
        updateAt: null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        headUrl: [
          { required: true, message: "前图图片不能为空", trigger: "blur" }
        ],
      }
    };
  },
  created() {
    this.queryParams.memberUserId = this.memberUserId;
    this.form.memberUserId = this.memberUserId;
    this.getList();
  },
  methods: {
    /** 查询用户轮播图列表 */
    getList() {
      this.loading = true;
      if (this.memberUserId != null){
        this.queryParams.memberUserId = this.memberUserId;
      }
      listMallMemberBanner(this.queryParams).then(response => {
        this.mallMemberBannerList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        memberUserId: null,
        name: null,
        headUrl: null,
        backgroundUrl: null,
        status: "0",
        type: null,
        sort: null,
        createAt: null,
        updateAt: null,
        delFlag: null
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.form.memberUserId = this.memberUserId;
      this.open = true;
      this.title = "添加用户小程序图";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      this.form.memberUserId = this.$route.params && this.$route.params.memberUserId;
      const id = row.id || this.ids
      getMallMemberBanner(id).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = "修改用户小程序图";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.id != null) {
            updateMallMemberBanner(this.form).then(response => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addMallMemberBanner(this.form).then(response => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$modal.confirm('是否确认删除用户小程序图编号为"' + ids + '"的数据项？').then(function() {
        return delMallMemberBanner(ids);
      }).then(() => {
        this.getList();
        this.$modal.msgSuccess("删除成功");
      }).catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      this.download('mall/mallMemberBanner/export', {
        ...this.queryParams
      }, `mallMemberBanner_${new Date().getTime()}.xlsx`)
    }
  }
};
</script>
